%%*****************************************************************
%% AHOcorr: corrector step for the AHO direction. 
%%
%% SDPT3: version 2.1 
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last modified: 7 Jul 99
%%*****************************************************************

  function  [dX,dy,dZ] = AHOcorr(blk,dX,dZ,A,rp,Rd,sigma,mu,hRd,...
                         Lsch,Usch,Psch,iscmpA,schur_opt,X,Z,V,d,B,hX);
%%
    hEinvRc = zeros(size(rp)); 
%%
    Vt = ops(V,'ctranspose'); 
    ONE  = ops(d,'ones'); 
    sigI = ops(ops(sigma*mu,'*',ONE),'spdiags',X); 
    dxdz = Prod2(blk,dX,dZ);  dxdz = ops(dxdz,'sym');    
    tmp  = Prod2(blk,X,Z);    tmp  = ops(tmp,'sym'); 
    Rc   = ops(sigI,'-',ops(tmp,'+',dxdz)); 
    clear dxdz; 
    Dsch = ops(d,'rank1inv',ONE,blk); 
%%
    for p = 1:size(blk,1);
       if (schur_opt(p) == 1);  
          EinvRc(p) = ops(Dsch(p),'.*',Prod3(blk(p,:),Vt(p),Rc(p),V(p),1)); 
          hEinvRc = hEinvRc + blktrace(blk(p,:),B(p,:),EinvRc(p)); 
       elseif (schur_opt(p) == 2); 
          tmp = ops(Dsch(p),'.*',Prod3(blk(p,:),Vt(p),Rc(p),V(p),1)); 
          EinvRc(p) = Prod3(blk(p,:),V(p),tmp,Vt(p),1);
          hEinvRc = hEinvRc + blktrace(blk(p,:),A(p,:),EinvRc(p)); 
       end;
    end;
    clear Rc; 
    rhs = rp + hRd - hEinvRc; 
    dy  = Usch \ (Lsch \(Psch * rhs));
    clear Lsch Usch Psch; 
    dZ  = ops(Rd,'-',Asum(blk,A,dy,iscmpA));
%%
%% compute dX
%%
    for p = 1:size(blk,1);
       if (schur_opt(p) == 1);  
          tmp = Prod3(blk(p,:),Vt(p),dZ(p),V(p),1); 
          tmp = Prod2(blk(p,:),hX(p),tmp); tmp = ops(tmp,'sym');  
          dX(p)= Prod3(blk(p,:),V(p),ops(EinvRc(p),'-',ops(Dsch(p),'.*',tmp)),Vt(p),1);
       elseif (schur_opt(p) == 2);
          tmp = Prod2(blk(p,:),X(p),dZ(p));  tmp = ops(tmp,'sym'); 
          tmp = Prod3(blk(p,:),Vt(p),tmp,V(p),1); 
          dX(p)= ops(EinvRc(p),'-',Prod3(blk(p,:),V(p),ops(Dsch(p),'.*',tmp),Vt(p),1));
       end;
    end;
%%=================================================================

