%%*****************************************************************
%% AHOcorrhlf: corrector for the AHO direction in the  
%%             homogeneous algorithm
%%
%% SDPT3: version 2.1 
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last modified: 7 Jul 99
%%*****************************************************************

  function [dX,dy,dZ,dtau,dkap] = AHOcorrhlf(blk,dX,dZ,dtau,dkap,A,C,b,rp,Rd,hRd,sigma,mu,eta,Lsch,Usch,Psch,iscmpA,tau,kap,schur_opt,X,Z,V,d,B,hX);
%%
    m = length(rp)-1; 
    EinvRc = cell(size(X)); hEinvRc = zeros(size(rp));
    rc  = sigma*mu-kap*tau-dkap*dtau; 
%%
    Vt = ops(V,'ctranspose'); 
    hC = Prod3(blk,Vt,C,V,1); 
    ONE  = ops(d,'ones'); 
    sigI = ops(ops(sigma*mu,'*',ONE),'spdiags',X); 
    dxdz = Prod2(blk,dX,dZ);  dxdz = ops(dxdz,'sym'); 
    tmp  = Prod2(blk,X,Z);    tmp  = ops(tmp,'sym'); 
    Rc   = ops(sigI,'-',ops(tmp,'+',dxdz)); 
    clear  dxdz; 
    Dsch = ops(d,'rank1inv',ONE,blk); 
%%
    for p = 1:size(blk,1); 
       if (schur_opt(p) == 1);
          EinvRc(p) = ops(Dsch(p),'.*',Prod3(blk(p,:),Vt(p),Rc(p),V(p),1)); 
          hEinvRc = hEinvRc + ...
          [blktrace(blk(p,:),B(p,:),EinvRc(p)); -blktrace(blk(p,:),hC(p),EinvRc(p))]; 
       elseif (schur_opt(p) == 2); 
          EinvRc(p) = ops(Dsch(p),'.*',Prod3(blk(p,:),Vt(p),Rc(p),V(p),1)); 
          EinvRc(p) = Prod3(blk(p,:),V(p),EinvRc(p),Vt(p),1);
          hEinvRc = hEinvRc + ...
          [blktrace(blk(p,:),A(p,:),EinvRc(p)); -blktrace(blk(p,:),C(p),EinvRc(p))]; 
       end;
    end;
    clear Rc; 
    rhs = eta*rp + [zeros(m,1); rc/tau] + eta*hRd - hEinvRc; 
    [dy,dtau]  = schurhlf([],rhs,b,kap,tau,mu,0,[],Lsch,Usch,Psch);
    clear Lsch Usch Psch; 
%%
    dZ  = ops(ops(eta,'*',Rd),'-',ops(Asum(blk,A,dy,iscmpA),'-',ops(dtau,'*',C)));
    for p = 1:size(blk,1);
       if (schur_opt(p) == 1); 
          tmp = Prod3(blk(p,:),Vt(p),dZ(p),V(p),1); 
          tmp = Prod2(blk(p,:),hX(p),tmp); tmp = ops(tmp,'sym');  
          dX(p) = Prod3(blk(p,:),V(p),ops(EinvRc(p),'-',ops(Dsch(p),'.*',tmp)),Vt(p),1);
       elseif (schur_opt(p) == 2); 
          tmp = Prod2(blk(p,:),X(p),dZ(p));  tmp = ops(tmp,'sym'); 
          tmp = Prod3(blk(p,:),Vt(p),tmp,V(p),1); 
          tmp = Prod3(blk(p,:),V(p),ops(Dsch(p),'.*',tmp),Vt(p),1); 
          dX(p) = ops(EinvRc(p),'-',tmp); 
       end;
    end;
    dkap = rc/tau - (kap/tau)*dtau; 
%%=================================================================


