%%******************************************************************
%% Atriu: decompose a symmetric matrix A into 
%% 
%%        A = R + R', where R is upper triangular. 
%%
%% SDPT3: version 2.1
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last Modified: 7 Jul 99
%%******************************************************************

   function AR = Atriu(A); 

   if ~iscell(A); 
      [m,n] = size(A); 
      if (n > 1) & ~issparse(A); 
         AR = triu(A)-spdiags(0.5*diag(A),0,n,n);
      else; 
         AR = []; 
      end; 
   else; 
      AR = cell(size(A));
      for p = 1:size(A,1); 
          for k = 1:size(A,2); 
              AR{p,k} = Atriu(A{p,k}); 
          end;
      end; 
   end;
%%=================================================================
