%%*****************************************************************
%% GTcorr: corrector step for the GT direction. 
%%
%% SDPT3: version 2.1
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last modified: 7 Jul 99
%%*****************************************************************

  function  [dX,dy,dZ] = GTcorr(blk,dX,dZ,A,rp,Rd,sigma,mu,hRd,...
             Uchol,iscmpA,ZH,invZH,d,sv2,phi2,psi2);
%%    
    invZHt = ops(invZH,'ctranspose'); 
    dxdz = Prod2(blk,dX,dZ); 
    tmp = Prod3(blk,ZH,dxdz,invZH,0);  %% do not symmetrize. 
    clear dxdz ZH; 
    dsqrt = ops(d,'sqrt'); 
    tmp = Prod2(blk,ops(ops(1,'./',dsqrt),'spdiags',Rd),tmp); 
    tmp = Prod2(blk,tmp,ops(dsqrt,'spdiags',Rd)); 
    Rq  = ops(tmp,'sym'); 
%%
    tmp = ops(ops(sigma*mu,'-',sv2),'spdiags',Rd);
    tmp = ops(tmp,'-',Rq); 
    clear Rq;
    DEinv = ops(ops(dsqrt,'.*',phi2),'rank1inv',ops(1,'./',dsqrt),blk);
    EinvRc = Prod3(blk,invZH,ops(DEinv,'.*',tmp),invZHt,1); 
    rhs = rp + hRd - blktrace(blk,A,EinvRc); 
%%
    tmp  = ops(ops(ops(dsqrt,'.*',d),'.*',psi2),'rank1',dsqrt,blk);
    Dsch = ops(tmp,'.*',DEinv); 
    clear DEinv; 
%%
    dy = mexbsolve(Uchol,mexbsolve(Uchol,rhs,2),1); 
    dZ  = ops(Rd,'-',Asum(blk,A,dy,iscmpA));
    tmp = Prod3(blk,invZHt,dZ,invZH,1);  
    tmp = ops(Dsch,'.*',tmp); 
    clear Dsch; 
    tmp = Prod3(blk,invZH,tmp,invZHt,1); 
    dX  = ops(EinvRc,'-',tmp); 
%%====================================================================




