%%*****************************************************************
%% GTcorrhlf: corrector for the GT direction in the 
%%            homogeneous algorithm
%%
%% SDPT3: version 2.1 
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last modified: 7 Jul 99
%%*****************************************************************

  function  [dX,dy,dZ,dtau,dkap] = GTcorrhlf(blk,dX,dZ,dtau,dkap,A,C,b,rp,Rd,hRd,sigma,mu,eta,Uchol,Lsch,Usch,Psch,iscmpA,tau,kap,ZH,invZH,d,sv2,phi2,psi2);

    m = length(rp)-1;                       
    rc  = sigma*mu-kap*tau-dkap*dtau; 
%%    
    invZHt = ops(invZH,'ctranspose'); 
    dxdz = Prod2(blk,dX,dZ); 
    tmp = Prod3(blk,ZH,dxdz,invZH,0);  %% do not symmetrize. 
    clear dxdz ZH; 
    dsqrt = ops(d,'sqrt'); 
    tmp = Prod2(blk,ops(ops(1,'./',dsqrt),'spdiags',Rd),tmp); 
    tmp = Prod2(blk,tmp,ops(dsqrt,'spdiags',Rd)); 
    Rq  = ops(tmp,'sym'); 
%%
    tmp = ops(ops(sigma*mu,'-',sv2),'spdiags',Rd);
    tmp = ops(tmp,'-',Rq); 
    clear Rq;
    DEinv = ops(ops(dsqrt,'.*',phi2),'rank1inv',ops(1,'./',dsqrt),blk);
    EinvRc = Prod3(blk,invZH,ops(DEinv,'.*',tmp),invZHt,1); 
    rhs  = eta*rp + [zeros(m,1); rc/tau] + eta*hRd ...
           - [blktrace(blk,A,EinvRc); -blktrace(blk,C,EinvRc)]; 
    [dy,dtau]  = schurhlf([],rhs,b,kap,tau,mu,1,Uchol,Lsch,Usch,Psch);
    clear Uchol Lsch Usch Psch; 
%%
    tmp  = ops(ops(ops(dsqrt,'.*',d),'.*',psi2),'rank1',dsqrt,blk);
    Dsch = ops(tmp,'.*',DEinv); 
    clear DEinv; 
%%
    dZ  = ops(ops(eta,'*',Rd),'-',ops(Asum(blk,A,dy,iscmpA),'-',ops(dtau,'*',C)));
    tmp = Prod3(blk,invZHt,dZ,invZH,1);  
    tmp = ops(Dsch,'.*',tmp); 
    clear Dsch; 
    tmp = Prod3(blk,invZH,tmp,invZHt,1); 
    dX  = ops(EinvRc,'-',tmp); 
    dkap = rc/tau - (kap/tau)*dtau; 
%%====================================================================




