%%*****************************************************************
%% HKMcorr: corrector step for the HKM direction. 
%%
%% SDPT3: version 2.1 
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last modified: 7 Jul 99
%%*****************************************************************

  function [dX,dy,dZ] = HKMcorr(blk,dX,dZ,A,rp,Rd,sigma,mu,hRd,Uchol,iscmpA,X,Zinv);

%%
    Rq = Prod3(blk,dX,dZ,Zinv,0);  clear dX dZ; 
    Rq = ops(Rq,'sym'); 
    EinvRc = ops(ops(sigma*mu,'*',Zinv),'-',X); 
    EinvRc = ops(EinvRc,'-',Rq);
    clear Rq; 
    rhs = rp + hRd - blktrace(blk,A,EinvRc);
%%
    dy = mexbsolve(Uchol,mexbsolve(Uchol,rhs,2),1); 
    dZ  = ops(Rd,'-',Asum(blk,A,dy,iscmpA));  clear Rd; 
    tmp = Prod3(blk,Zinv,dZ,X);  clear X  Zinv; 
    tmp = ops(tmp,'sym'); 
    dX  = ops(EinvRc,'-',tmp); 
%%=========================================================



