%%*****************************************************
%% HKMcorrhlf: corrector for the HKM direction in the
%%             homogeneous algorithm
%%
%% SDPT3: version 2.1 
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last Modified: 7 Jul 99
%%*****************************************************

 function  [dX,dy,dZ,dtau,dkap] = HKMcorrhlf(blk,dX,dZ,dtau,dkap,A,C,b,rp,Rd,hRd,sigma,mu,eta,Uchol,Lsch,Usch,Psch,iscmpA,tau,kap,X,Zinv);

    m = length(rp)-1; 
    rc  = sigma*mu-kap*tau-dkap*dtau; 
%%
    Rq = Prod3(blk,dX,dZ,Zinv); Rq = ops(Rq,'sym');          
    EinvRc = ops(ops(sigma*mu,'*',Zinv),'-',X); 
    EinvRc = ops(EinvRc,'-',Rq);
    clear Rq; 
    rhs = eta*rp + [zeros(m,1); rc/tau] + eta*hRd ...
          - [blktrace(blk,A,EinvRc); -blktrace(blk,C,EinvRc)];  
    [dy,dtau] = schurhlf([],rhs,b,kap,tau,mu,1,Uchol,Lsch,Usch,Psch);
    clear Uchol Lsch Usch Psch; 
%%    
    dZ  = ops(ops(eta,'*',Rd),'-',ops(Asum(blk,A,dy,iscmpA),'-',ops(dtau,'*',C)));
    tmp = Prod3(blk,Zinv,dZ,X);  tmp = ops(tmp,'sym'); 
    dX  = ops(EinvRc,'-',tmp); 
    dkap = rc/tau - (kap/tau)*dtau; 
%%===================================================== 







