%%*********************************************************************
%% NTcorrhlf: corrector for the NT direction in the
%%            homogeneous algorithm
%%
%% SDPT3: version 2.1 
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last Modified: 7 Jul 99
%%*********************************************************************

 function  [dX,dy,dZ,dtau,dkap] = NTcorrhlf(blk,dX,dZ,dtau,dkap,A,C,b,rp,Rd,hRd,sigma,mu,eta,Uchol,Lsch,Usch,Psch,iscmpA,tau,kap,W,G,sv);
      
    m = length(rp)-1;                       
    rc  = sigma*mu-kap*tau-dkap*dtau; 
%%
    hdZ = Prod3(blk,G,dZ,ops(G,'ctranspose'),1);
    hdX = ops(ops(ops(0,'-',sv),'spdiags',G ), '-', hdZ); 
    tmp = Prod2(blk,hdX,hdZ);  tmp = ops(tmp,'sym'); 
    clear hdX hdZ; 
    Dinv = ops(sv,'rank1inv',ops(sv,'ones'),blk); 
    Rq  = ops(Dinv,'.*',tmp);  
    clear Dinv; 
%%
    tmp = ops( ops(ops(sigma*mu,'./',sv),'-',sv), 'spdiags', G );
    EinvRc = Prod3(blk,ops(G,'ctranspose'),ops(tmp,'-',Rq),G,1); 
    clear G  Rq;
    rhs  = eta*rp + [zeros(m,1); rc/tau] + eta*hRd ...
           - [blktrace(blk,A,EinvRc); -blktrace(blk,C,EinvRc)]; 
    [dy,dtau]  = schurhlf([],rhs,b,kap,tau,mu,1,Uchol,Lsch,Usch,Psch);
    clear Uchol Lsch Usch Psch; 
%%
    dZ  = ops(ops(eta,'*',Rd),'-',ops(Asum(blk,A,dy,iscmpA),'-',ops(dtau,'*',C)));
    tmp = Prod3(blk,W,dZ,W,1); 
    dX  = ops(EinvRc,'-',tmp); 
    dkap = rc/tau - (kap/tau)*dtau; 
%%=====================================================================  




