%%******************************************************************
%% cholaug: compute Cholesky factorization of X. 
%%          
%%  [Xchol,indef] = blkchol(blk,X); 
%%  
%%  X = Xchol'*Xchol;
%%
%% SDPT3: version 2.1
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last Modified: 7 Jul 99
%%******************************************************************
 
  function [Xchol,indef] = blkchol(blk,X); 

  if ~iscell(X); 
     n = length(X); 
     if strcmp(blk{1},'nondiag');
        [Xchol,indef] = chol(X); 
     elseif strcmp(blk{1},'diag'); 
        if all(X); 
           indef = 0; 
           Xchol = sqrt(X);  
        else;
           indef = 1; 
        end; 
     end; 
  else; 
     Xchol = cell(size(X));  
     for p = 1:size(blk,1); 
        [Xchol{p},indef(p)] = blkchol(blk(p,:),X{p});
     end;
     indef = max(indef); 
  end; 
%%=================================================================      


