%%**********************************************************************
%% blktrace: compute the vector 
%%
%%    trAX = blktrace(blk,A,X,options);
%% 
%%  input: blk = a cell array describing the block structure of X. 
%%         A = a square matrix or a column vector
%%             or a pxm CELL ARRAY, where A{i,j} is 
%%             a square matrix or a column vector.
%%         X = a square matrix or a column vector
%%             or a px1 CELL ARRAY, where X{i} is 
%%             a square matrix or a column vector.
%%   options = 1,  matrices are symmetric (default). 
%%             0,  matrices are not symmetric. 
%%
%%  output trAX = mx1 vector, 
%%         where trAX(j) = sum_{i=1}^p real(trace(A{i,j}*X{i}')).
%%              
%%
%% SDPT3: version 2.1 
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last Modified: 7 Jul 99
%%**********************************************************************

  function trAX = blktrace(blk,A,X,options); 

  if (nargin == 3); options = 1; end;   
  trAX = mextrace(blk,A,X,options); 

%%**********************************************************************




