%%*************************************************************************
%% parameters.m: set OPTIONS structure to specify default
%%               parameters for sdp.m and sdphlf.m 
%%
%% OPTIONS.vers        : version of direction to use.  
%% OPTIONS.gam         : step-length parameter,
%% OPTIONS.predcorr    : whether to use Mehrotra predictor-corrector. 
%% OPTIONS.expon       : exponent in decrease of centering parameter sigma. 
%% OPTIONS.gaptol      : tolerance for duality gap as a fraction of the 
%%                       value of the objective functions. 
%% OPTIONS.inftol      : tolerance for stopping due to suspicion of 
%%                       infeasibility.
%% OPTIONS.steptol     : toloerance for stopping due to small steps.
%% OPTIONS.maxit       : maximum number of iteration allowed 
%% OPTIONS.sw2PC_tol   : use PC-rule only if infeasibility < sw2PC_tol.
%% OPTIONS.use_corrprim: 1, if correcting primal infeasibility each step 
%%                          (after feasibility attained), else 0.
%% OPTIONS.printyes    : 1, if want to display result in each iteration, 
%%                          else = 0. 
%% OPTIONS.scale_data  : 1, if want to scale the data before solving the problem, 
%%                          else 0
%% OPTIONS.schurfun    : a string for evaluating user supplied 
%%                       schur complement matrix routine. 
%% OPTIONS.schurfun_parms: a cell array containing parameters needed in 
%%                         user supplied Schur routin. 
%% OPTIONS.randnstate  : state to be used for matlab 5 random normal generator.
%%
%% SDPT3: version 2.1 
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last modified: 7 Jul 99
%%*************************************************************************

   OPTIONS.vers          = 2; 
   OPTIONS.gam           = 0;  
   OPTIONS.predcorr      = 1;
   OPTIONS.expon         = [3 1 1 1]; 
   OPTIONS.gaptol        = 1e-8;
   OPTIONS.inftol        = 1e-8; 
   OPTIONS.steptol       = 1e-6; 
   OPTIONS.maxit         = 50; 
   OPTIONS.sw2PC_tol     = inf;
   OPTIONS.use_corrprim  = 0;
   OPTIONS.printyes      = 1; 
   OPTIONS.scale_data    = 0; 
   OPTIONS.schurfun       = [];
   OPTIONS.schurfun_parms = []; 
   OPTIONS.randnstate     = 0; 
%%=============================================================

