%%************************************************************
%% pathres: calculate closeness to the central path
%%
%%   path_res = pathres(blk,X,Zchol,mu);
%%
%%   path_res = 1 - min(eig(X*Z))/mu;
%%
%% SDPT3: version 2.1 
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last modified: 7 Jul 99
%%************************************************************

    function path_res = pathres(blk,X,Zchol,mu);

    M = Prod3(blk,Zchol,X,ops(Zchol,'ctranspose'),4); 
    eigXZ = ops(blkeig(blk,M),'real');    
    for p = 1:size(blk,1);  
        path_res(p) = abs(1-min(eigXZ{p})/mu); 
    end;
    path_res = max(path_res); 
%%************************************************************


