%%********************************************************************
%% scaling: scale the SDP data so that A_k,C,b have unit norm. 
%%          Because of scaling, the objective function is 
%%          modified: 
%% 
%%          old obj function = (normb*normC) (new obj function).
%%
%% SDPT3: version 2.1 
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last modified: 7 Jul 99
%%********************************************************************

   function [A,C,b,X0,y0,Z0,normA,normC,normb] = scaling(blk,A,C,b,X0,y0,Z0); 

   m = size(A,2); 
   normA = zeros(m,1);
   for k = 1:m; 
       normAk = max(1,ops(A(:,k),'norm')); 
       A(:,k) = ops(A(:,k),'/',normAk); 
       normA(k) = normAk; 
   end;
   b = b./normA; normb = max(1,norm(b)); 
   b = b/normb; 
 
   normC = max(1,ops(C,'norm')); 
   C  = ops(C,'/',normC); 

   X0 = ops(X0,'/',normb); 
   y0 = y0.*normA/normC; 
   Z0 = ops(Z0,'/',normC); 
%%====================================================================
