%%******************************************************************
%% convthetaG: convert thetaG.dat into theta.dat
%%
%% SDPT3: version 2.1
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last Modified: 7 Jul 99
%%******************************************************************
 
  function [blk,A,C,b] = convthetaG(blk,A,C,b);

   n=blk{2}-1;
   blk{2}=n;
   m=size(A,2);
   is=[]; js=[];
   C{1}=-ones(n);
   for idx=n+2:m 
       [i,j,v]=find(A{idx});
       is=[is;i(1)];
       js=[js;i(2)];
   end;
   A=cell(1,m-n);
   A{1}=-speye(n);
   for idx=2:m-n
       A{idx}=sparse(n,n);
       A{idx}(is(idx-1),js(idx-1))=-.5;
       A{idx}(js(idx-1),is(idx-1))=-.5;
   end;
   b=sparse(m-n,1);
   b(1)=-1;
   end;
%%******************************************************************