%%****************************************************
%% mcpGTsch: compute schur matrix of GT direction
%%            for MCP and maxG problems.  
%%
%% [schur,hRd] = mcpGTsch(invZHt,Dsch,Rd,schurfun_parms); 
%%
%%   Ak= -ek*ek'.
%%
%% SDPT3: version 2.1
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last Modified: 7 Jul 99
%%****************************************************

 function [schur,hRd] = mcpGTsch(invZHt,Dsch,Rd,schurfun_parms); 

  if ~exist('Rd'); Rd = []; hRd = []; end;

  zz = invZHt{1};  clear invZHt;   
  E = Dsch{1};     clear Dsch; 
  m = length(zz); 
  for i = 1:m
     zi = zz(:,i);      
     for j = 1:i
         w = zi.*zz(:,j); 
         schur(i,j) = w'*E*w; 
     end;
  end;
  schur = schur + tril(schur,-1)'; 
%%
  if ~isempty(Rd); 
     hRd = zeros(m,1); 
     blk{1} = 'nondiag';  blk{2} = m; 
     tmp = Prod3(blk, zz, Rd{1}, zz' , 1); 
     tmp = E.*tmp; 
     clear Rd;
     for k=1:m; 
         hRd(k) = -zz(:,k)'*(tmp*zz(:,k)); 
     end;
  end;
%%****************************************************

 
