%%****************************************************
%% mcpHKMsch: compute schur matrix of HKM direction
%%            for MCP and maxG problems.  
%%
%% [schur,hRd] = mcpHKMsch(X,Zinv,Rd,schurfun_parms); 
%%
%%   Ak= -ek*ek';
%%
%% SDPT3: version 2.1
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last Modified: 7 Jul 99
%%****************************************************

  function [schur,hRd] = mcpHKMsch(X,Zinv,Rd,schurfun_parms); 
  
  if ~exist('Rd'); Rd = []; hRd = []; end;
  x = X{1};        clear X;
  zinv = Zinv{1};  clear Zinv; 
  schur = x .* zinv;
  
  if ~isempty(Rd); 
     m = size(x,1); 
     hRd = zeros(m,1); 
     tmp = Rd{1} * x; 
     clear Rd;
     for k=1:m; hRd(k) = -zinv(k,:)*tmp(:,k); end;
  end;
%%****************************************************
