%%****************************************************
%% mcpNTsch: compute schur matrix of NT direction
%%            for MCP and maxG problems.  
%%
%%  [schur,hRd] = mcpNTsch(W,Rd,schurfun_parms); 
%% 
%%  Ak = -ek*ek'; 
%%
%% SDPT3: version 2.1
%% Copyright (c) 1997 by
%% K.C. Toh, M.J. Todd, R.H. Tutuncu
%% Last Modified: 7 Jul 99
%%****************************************************

  function [schur,hRd] = mcpNTsch(W,Rd,schurfun_parms); 
  
  if ~exist('Rd'); Rd = []; hRd = []; end;
  w = W{1}; clear W; 
  schur = w .* w;
   
  if ~isempty(Rd); 
     m = size(w,1); 
     hRd = zeros(m,1);
     tmp = Rd{1}*w; 
     clear Rd; 
     for k=1:m; hRd(k) = -w(k,:)*tmp(:,k); end;
  end; 
%%****************************************************
 
  

